function coste=coste(u,v,T,N)
v=reshape(v,12,1);
%control predictivo de horizonte de prediccin N muestreado con periodo T
x=v(1:6);%condiciones iniciales
r=v(7:12);%referencia

%PARMETROS FSICOS
hov.masa=0.894;%masa
hov.inercia=0.0125;%momento de inercia de rotacin
hov.r=0.05;%distancia motor/eje de simetra
hov.fdir=1*0.615;%fuerza de los motores en sentido directo
hov.finv=-1*0.3;%fuerza de los motores en sentido inverso
hov.rl=0.1;%c. rozamiento viscoso lineal
hov.rr=0.05;%c. rozamiento viscoso rotacional

A=[0 0 1 0 0 0;
   0 0 0 1 0 0
   0 0 -hov.rl 0 0 0;
   0 0 0 -hov.rl 0 0;
   0 0 0 0 0 1;
   0 0 0 0 0 -hov.rr];

%simula el sistema y calcula la funcin de coste
u1=u(1); %bucle en I
u2=u(2); %bucle en J
xs=x;
%SATURACIONES
U1=u1+(u1>hov.fdir)*(hov.fdir-u1)+(u1<hov.finv)*(hov.finv-u1);
U2=u2+(u2>hov.fdir)*(hov.fdir-u2)+(u2<hov.finv)*(hov.finv-u2);
for i=1:N %simulacion
    xs=xs+T*(A*xs+[0 0 cos(xs(5))*(U1+U2)/hov.masa sin(xs(5))*(U1+U2)/hov.masa 0 hov.r/hov.inercia*(U1-U2)]');
end
%sopeso los errores cuadraticos y los almaceno en una matriz
e2=(xs-r).^2;
er2=[1 1 0 0 0 0]*e2;
ev2=[0 0 1 1 0 0]*e2;
eth2=(mod((xs(5)-r(5))+pi,2*pi)-pi).^2;

coste=er2+log(1+100*er2)+0*10*ev2+0*0.001*eth2;


