function coste=coste(u,v,T,N)
v=reshape(v,12,1);
%control predictivo de horizonte de prediccin N muestreado con periodo T
x=v(1:6);%condiciones iniciales
r=v(7:12);%referencia

%PARMETROS FSICOS
hov.masa=0.894;%masa
hov.inercia=0.0125;%momento de inercia de rotacin
hov.r=0.05;%distancia motor/eje de simetra
hov.fdir=1*0.615;%fuerza de los motores en sentido directo
hov.finv=-1*0.3;%fuerza de los motores en sentido inverso
hov.rl=0.1;%c. rozamiento viscoso lineal
hov.rr=0.05;%c. rozamiento viscoso rotacional

A=[0 0 1 0 0 0;
   0 0 0 1 0 0
   0 0 -hov.rl 0 0 0;
   0 0 0 -hov.rl 0 0;
   0 0 0 0 0 1;
   0 0 0 0 0 -hov.rr];

%simula el sistema y calcula la funcin de coste
u1=u(1);%primer periodo
u2=u(2); 
xs=x;%SATURACIONES
U1=u1+(u1>hov.fdir)*(hov.fdir-u1)+(u1<hov.finv)*(hov.finv-u1);
U2=u2+(u2>hov.fdir)*(hov.fdir-u2)+(u2<hov.finv)*(hov.finv-u2);
xs=xs+T*(A*xs+[0 0 cos(xs(5))*(U1+U2)/hov.masa sin(xs(5))*(U1+U2)/hov.masa 0 hov.r/hov.inercia*(U1-U2)]');

u1=u(3);%segundo periodo
u2=u(4); 
U1=u1+(u1>hov.fdir)*(hov.fdir-u1)+(u1<hov.finv)*(hov.finv-u1);
U2=u2+(u2>hov.fdir)*(hov.fdir-u2)+(u2<hov.finv)*(hov.finv-u2);
for i=2:N %simulacion del resto del horizonte
    xs=xs+T*(A*xs+[0 0 cos(xs(5))*(U1+U2)/hov.masa sin(xs(5))*(U1+U2)/hov.masa 0 hov.r/hov.inercia*(U1-U2)]');
end
%sopeso los errores cuadraticos y los almaceno en una matriz
coste=[1 1 1 1 0 0]*(xs-r).^2;

